#include "crc.h"
#include "ibitstr.h"
#include "header.h"
#include "subband.h"

#include <wtypes.h>

/* A abstract class to pass values to maplay. From the Win32 API, we can only
	pass one 32-bit value to a thread. This will be a pointer to a object
	of this class. The Args class contains the seeking control variables
	needed for both MPEG and MCI files. */

class Args
{
	public:

	Args() {}
	virtual ~Args() {}

	int desired_position;
	BOOL position_change;
	HWND hWnd;

};

// A class to contain arguments for maplay.
class MPEG_Args : public Args
{
public:

	MPEG_Args()
	{
		stream=NULL;
		crc=NULL;
		MPEGheader=NULL;
		hWnd=NULL;
		phwo=NULL;
		which_c=both;
		desired_position=0;
		position_change = FALSE;
	}

	Ibitstream *stream;
	Crc16 *crc;
	Header *MPEGheader;
	HWAVEOUT *phwo;
	enum e_channels which_c;

	~MPEG_Args() { }
};

// A class to hold the arguments for MCI playing.
class MCI_Args : public Args {

public:
	MCI_Args()
	{
		hWnd = NULL;
		desired_position = 0;
		position_change = FALSE;
		playing = FALSE;
	}

	BOOL playing;
};


