#ifndef LAYERIII_H
#define LAYERIII_H

#include "all.h"
#include "l3type.h"
#include "ibitstr.h"
#include "obuffer.h"
#include "bit_res.h"
#include "header.h"
#include "synfilt.h"

#define SSLIMIT 18
#define SBLIMIT 32

// Layer III scalefactors
void III_get_scale_factors(III_scalefac_t *scalefac,
									III_side_info_t *si,
									Bit_Reserve *br,
									int gr, int ch);

void III_hufman_decode(int is[SBLIMIT][SSLIMIT], III_side_info_t *si, int ch, int gr,
								int part2_start, Header *header, Bit_Reserve *br);

void III_dequantize_sample(int is[SBLIMIT][SSLIMIT], real xr[SBLIMIT][SSLIMIT], III_scalefac_t *scalefac,
									gr_info_s *gr_info, int ch, Header *header);

void III_reorder (real xr[SBLIMIT][SSLIMIT], real ro[SBLIMIT][SSLIMIT],
						gr_info_s *gr_info, Header *header);

void III_stereo(real xr[2][SBLIMIT][SSLIMIT], real lr[2][SBLIMIT][SSLIMIT],
					 III_scalefac_t *scalefac, gr_info_s *gr_info, Header *header);

void III_antialias(real xr[SBLIMIT][SSLIMIT], real hybridIn[SBLIMIT][SSLIMIT],
						 gr_info_s *gr_info);

void inv_mdct(real *in, real *out, int block_type);

void III_hybrid(real *fsIn, real *tsOut, int sb, int ch,
					 gr_info_s *gr_info);

void l3decoder(Ibitstream *stream, Header *header, Bit_Reserve *br,
					III_side_info_t *pIII_side_info, III_scalefac_t *pIII_scalefac,
					SynthesisFilter *filter1, SynthesisFilter *filter2,
					Obuffer *buffer);

#endif
